#ifndef _KGR_PATCH_BSC1124734_H
#define _KGR_PATCH_BSC1124734_H

#if IS_ENABLED(CONFIG_KVM_INTEL)

int kgr_patch_bsc1124734_init(void);
void kgr_patch_bsc1124734_cleanup(void);


struct kvm_vcpu;
struct msr_data;

int kgr_handle_vmoff(struct kvm_vcpu *vcpu);
void kgr_vmx_free_vcpu(struct kvm_vcpu *vcpu);
int kgr_vmx_set_msr(struct kvm_vcpu *vcpu, struct msr_data *msr_info);

#define KGR_PATCH_BSC1124734_FUNCS					\
	KGR_PATCH_OBJ(handle_vmoff, kgr_handle_vmoff, "kvm_intel"),	\
	KGR_PATCH_OBJ(vmx_free_vcpu, kgr_vmx_free_vcpu, "kvm_intel"),	\
	KGR_PATCH_OBJ(vmx_set_msr, kgr_vmx_set_msr, "kvm_intel"),	\

#else /* !IS_ENABLED(CONFIG_KVM_INTEL) */

static inline int kgr_patch_bsc1124734_init(void) { return 0; }

static inline void kgr_patch_bsc1124734_cleanup(void) {}

#define KGR_PATCH_BSC1124734_FUNCS

#endif /* IS_ENABLED(CONFIG_KVM_INTEL) */
#endif /* _KGR_PATCH_BSC1124734_H */
